
Ryzom - Bug # 908

Status: Closed Priority: Normal
Author: lubos Category: Client: General
Created: 05/17/2010 Assignee: kervala
Updated: 05/28/2010 Due date:
Subject: Incorrect method CMusicPlayer::previous()
Description

Better implementation is:

if (_Songs.empty())
    return;

if (_CurrentSong == 0)
    _CurrentSong%=_Songs.size()-1;
else
    _CurrentSong--;

play ();

History
#1 - 05/17/2010 09:52 am - kaetemi

How is that better?

#2 - 05/17/2010 10:03 am - lubos

When is _CurrentSong 0 and is decremented, then plays random song.
(Little fix - _CurrentSong=_Songs.size()-1; )

#3 - 05/17/2010 10:08 am - kaetemi

Just wondering
why not

if (!_Songs.empty())
{
    if (_CurrentSong)
        --_CurrentSong;
    else
        _CurrentSong = _Songs.size()-1;

    play ();
}
#4 - 05/17/2010 10:11 am - kervala

I tried (to be sure) and _CurrentSong-- when _CurrentSong == 0 gives _CurrentSong = 0xffffffff and _CurrentSong %= _Songs.size() gives
_CurrentSong = _Songs.size() - 1

So excepted for an "better understanding" aspect, it's not a bug :)

EDIT: Btw I'm not sure this behavior is identical on all systems...

#5 - 05/17/2010 10:19 am - kaetemi

I quite like this one too:

--_CurrentSong;
_CurrentSong = CurrentSong & ((~CurrentSong) >> 16);

(ignore any typos)
Math is generally faster than branching ^^

#6 - 05/17/2010 11:19 am - kervala
- Status changed from New to Assigned
- Assignee set to kervala

Thanks for noticing this bug and for providing patch :)

#7 - 05/17/2010 11:28 am - kervala
- Status changed from Assigned to Resolved
- % Done changed from 0 to 100

Applied in changeset r173.

#8 - 05/28/2010 05:24 pm - vl
- Status changed from Resolved to Closed
